### 2024年3月24日开发日志

在对赛题有了较为全面的了解之后，我们一致认为为了更好的完成赛题，可以先深入研究Linux内核中关于Slab分配器的源代码。

#### 目标：
- 详细阅读Linux内核中关于Slab分配器的源代码。
- 理解Slab分配器的原理、数据结构和实现细节。
- 梳理代码结构，了解各个模块之间的关系。
- 记录关键代码片段和注释，以备后续分析和参考。

#### 进度：

1. 阅读Slab分配器相关文档：
在开始阅读源代码之前，我们先查阅了一些关于Slab分配器的文档，包括官方文档和一些开发者的博客。
2. 下载并编译Linux内核源代码：

3. 定位Slab分配器源代码：
在源代码目录中，通过查找和分析，成功地定位了Slab分配器相关的源代码文件，包括 include/linux/slab_def.h、mm/slab_common.c和mm/slab.h等。

4. 详细阅读源代码：
逐行阅读Slab分配器的源代码，并记录了关键的注释和代码片段。

5. 理解数据结构和算法：
通过阅读源代码和注释，我逐渐理解了Slab分配器中涉及的数据结构和算法，包括Slab、Cache、对象管理等。

#### 收获总结：
1. slab 结构的高层组织结构如下图：
![alt text](images/image-1.png)

> 由于slab_def.h中的代码较少，故直接在文件中注释分析

#### 2. slab.h总体分析：
除了开头的一系列的头文件引用，一些宏定义和类型定义外，还对Slab分配器的相关定义、数据结构和函数声明，用于访问和操作Slab分配器中的数据结构。这些函数包括了对Slab的创建、销毁、分配、释放等操作，以及一些辅助函数可能用于在调试和性能分析。

如
1. 对struct slab 数据结构的定义：
描述了Slab分配器中的一个Slab的结构。
包含了内存页标志、分配器指针、空闲对象列表等信息。
![alt text](images/image-2.png)

2. struct kmem_cache 数据结构的定义：
每一个slab都有一个管理结构，也就是这个kmem_cache结构体。keme_cache将所有node上的slab连接起来，进行统一的调配。
描述了Slab分配器中的一个Slab缓存的结构。
包含了缓存的各种属性，比如对象大小、分配策略、构造函数等
![alt text](images/image-3.png)

1. __kmem_cache_create 函数声明:
创建一个Slab缓存。
参数包括缓存结构体和配置标志。
![alt text](images/image-4.png)

1. __kmem_cache_shutdown 函数声明:
关闭一个Slab缓存。
参数为缓存结构体。
![alt text](images/image-5.png)

1. kmalloc_slab 函数声明:
从Slab缓存中分配内存。
参数包括分配大小、配置标志和调用者信息。
![alt text](images/image-6.png)

1. slab_unmergeable 函数声明:
检查一个Slab缓存是否可以被合并。
参数为缓存结构体。
![alt text](images/image-7.png)

1. slab_ksize 函数声明:
计算一个Slab缓存的对象大小。
参数为缓存结构体。
![alt text](images/image-8.png)
