### 2024年4月14日开发日志

1. 在ubuntu 22.04中打开终端执行slab的文件查看命令：
```shell
sudo cat /proc/slabinfo
```
![alt text](images/image17.png)

包含了slab的诸多信息，如slab的名称、对象大小、对象数目、缓存大小、分配数目、释放数目等。

2. 工欲善其事，必先利其器。我们小组在之前的资料查询，源码分析和实际操作中，对于slab的原理和实现已经有了很全面且深刻的认识。接下来，我们将使用C++对Linux内核slab分配算法进行重新改写，实现面向对象的块内存分配与管理。方案如下：

- 使用类封装：
  使用C++类来封装SLAB分配器和内存块，提高代码的可读性和可维护性。
- 智能指针管理：
  使用智能指针来管理内存块的生命周期，避免内存泄漏和悬挂指针的问题。
- 模板化设计：
  利用C++模板来实现通用的SLAB分配器，使其支持不同大小的内存块。
- 异常处理：
  添加异常处理机制来处理内存分配失败等异常情况。
