### 2024年4月7日开发日志

通过对源码的阅读，对于slab算法和数据结构等有了更加深刻的认识：
***slab可以认为是进程与伙伴系统之前的中间层***
***每个slab其实就是一个page结构体，根据需要，划分成多个对象***

- slab层把不同的对象划分为所谓的高速缓存（cache）组，其中每个高速缓存都存放着不同类型的对象
- 每种对象类型对应一个高速缓存（cache）;
- 例如一个高速缓存存放task_struct结构体，而另外一个高速缓存存放struct inode结构体
- slab由一个或者多个物理上连续的页组成。每个高速缓存由多个slab组成
- 每个slab中包含多个对象，这些对象可以是已经分配的对象，也可以是空闲的对象，这些对象的大小都是相同的

![alt text](images/image-15.png)

1. 内核中的高速缓存组链表中包含多个不同大小的高速缓存
2. 而每个高速缓存中包含几种不同类型的slab链表，如full、partial、free等，分别表示已经分配、部分分配和未分配，为空闲的slab的三种状态
3. 每个slab链表中包含多个slab，每个slab由一个或者多个物理上连续的页组成
4. 每个slab中包含多个对象，这些对象可以是已经分配的对象，也可以是空闲的对象，这些对象的大小都是相同的，这个大小和高速缓存的大小是对应的